   import java.io.*;

    public class ADXiden
   {
       public static short getShort(byte[] data, int a)
      {
         return (short)( ( (data[a+1] & 0xff) << 8) | (data[a] & 0xff) );
      }
       public static int getInt(byte[] data, int a)
      {
         return((((data[a+3] & 0xff) << 0) | ((data[a+2] & 0xff) << 8) |
            		((data[a+1] & 0xff) << 16) | ((data[a] & 0xff) << 24)));
      }
       public static void main(String args[])throws IOException
      {
         BufferedReader br = null;
         String fname="";
         if(args.length > 0)
            fname = args[0];
         else
            br = new BufferedReader(new InputStreamReader(System.in));
      	
         if(br != null)
         {
            System.out.println("Please input a file to analyze.");
            fname = br.readLine();
         }
         if(fname.charAt(0)=='"')
            fname = fname.substring(1,fname.length()-1);
         File file = new File(fname);
         if(!file.exists())
         {
            System.out.println("The file you provided does not exist.");
            System.exit(0);
         }
         if(file.isDirectory() )
         {
            System.out.println("The location you provided appears to be a directory.");
            System.exit(0);
         }
         
         FileInputStream fr = new FileInputStream(file);
         byte[] data = new byte[64];
         fr.read(data);
         /*if(data[0]!=128 || data[1]!=0)
         {
            System.out.println("The file you provided appears to be invalid.");
            System.exit(0);
         }*/
         int bitdepth = data[6];
         System.out.println("Bitdepth - "+bitdepth);
         int channels = data[7];
         System.out.println("Channels - "+channels);
         int samplerate = getInt(data,8);
         System.out.println("Sample Rate - "+samplerate);
         int samples = getInt(data,12);
         System.out.println("Samples - "+samples);
         byte version = data[18];
         System.out.println("Version - "+version);
         int loop;
         int loopPoint=0;
         switch(version)
         {
            case 2:
            case 3:
               loop = getInt(data,24);
               if(loop>0){
                  loopPoint = getInt(data,28);
                  double seconds = (double)loopPoint/samplerate;
                  System.out.println("Loop Point - "+loopPoint+" (Approx. "+seconds+" seconds.)");
               }
               else
                  System.out.println("This ADX does not contain a loop point.");
               break;
            case 4:
               loop = getInt(data,36);
               if(loop>0){
                  loopPoint = getInt(data,40);
                  double seconds = (double)loopPoint/samplerate;
                  System.out.println("Loop Point - "+loopPoint+" (Approx. "+seconds+" seconds.)");
               }
               else
                  System.out.println("This ADX does not contain a loop point.");
               break;
            case 5:
               System.out.println("This ADX version does not support looping.");
               break;
         }
         
         System.exit(0);
      }
   }